package gnu.brl;

// readall.java -- reads a series of BRL expressions until EOF
// Copyright (C) 1999, 2000  Bruce R. Lewis and Eaton Vance Management
// See the file COPYING for license terms.

import kawa.lang.*;
import gnu.mapping.Procedure0or1;
import gnu.mapping.WrongType;
import gnu.mapping.InPort;

public class readall extends Procedure0or1 {
  public final Object apply0 ()
  {
    return apply1 (InPort.inDefault());
  }

  public final Object apply1 (Object arg1)
  {
    if (! (arg1 instanceof InPort))
      throw new WrongType (this.name(), 0, "input port");
    try
      {
	BRLRead lexer = new BRLRead((InPort)arg1);
	// System.out.println("Line " + ((InPort)arg1).getLineNumber() + ", column " + ((InPort)arg1).getColumnNumber());
	Object result = lexer.readListBody(-1);
	gnu.text.SourceError errors = lexer.getErrors();
	if (errors != null)
	  {
	    lexer.checkErrors(null, 0);
	    throw new GenericError("syntax error in brl-readall: "+errors.toString());
	  }
	return result;
      }
    catch (gnu.text.SyntaxException e)
      {
	throw new GenericError ("syntax error in brl-readall: " + e.toString ());
      }
    catch (java.io.IOException e)
      {
	throw new GenericError ("I/O exception in brl-readall: " + e.toString ());
      }
  }
}
